;Sterownik wiate schodowych Adam miaek v1.0 2011-01-26
;==============================================================================
$nomod
$nopaging
;================================================================== sfr bajty =
pcon    equ 087h        ;[2xser.][ramka]x[wcz.zas][wolny][wolny][zamr.][up.]
tcon    equ 088h        ;[irqt0][t0][irqt1][t1][irqint1][strob][irqint0][strob]
tmod    equ 089h        ;[t1<int1][t1<ex][m1][m0][t0<int0][t0<ex][m1][m0]
tl0     equ 08ah        ;licznik t0 (0-7)
th0     equ 08ch        ;licznik t0 (8-15)
p1      equ 090h        ;port 1
ie      equ 0a8h        ;irq: [nie wyczone]x[t2][serial][t1][int1][t0][int0]
p3      equ 0b0h        ;port 3
psw     equ 0d0h        ;[cy][ac]x[rs1][rs0][ov]x[p]
acc     equ 0e0h        ;akumulator
;============================================================= prywatne bajty =
pwm     equ 030h        ;licznik dla pwm
bright  equ 031h        ;jasno dla pwm

fadein  equ 01h         ;czas zjaniania ledw na wstpie                       ;dobierz
time    equ 40h         ;czas wiecenia ledw pen moc                        ;dobierz
fadeout equ 20h         ;czas ciemniania ledw na kocu                        ;dobierz
;========================================================== pocztek programu =
org 00h                 ;skok do gwnej ptli
sjmp reset              ;
org 0bh                 ;skok do obsugi przerwania timera/licznika t0
ajmp intt0              ;
;======================================================= reset ustawianie sfr =
org 3bh
reset:
mov tmod, #00000010b    ;sterowanie t0 tryb 2 (autoprzeadowyw. wartoci th)
mov tcon, #00010000b    ;wcz t0 
mov th0, #0f0h          ;dobierz do pynnej pracy pwm
mov tl0, #0f0h
;=============================================== ustawianie prywatnych bajtw =
mov p1, #255
mov p3, #255
mov r5, #255
;========================================================== dziaania wstpne =
mov ie, #10000010b      ;wcz przerwania z t0

pre:
mov a, r5               ;rozjanij ledy
cpl a
mov bright, a

mov r6, #fadein
pre1:
mov r7, #040h
djnz r7, $
djnz r6, pre1
djnz r5, pre            ;ptla rozjaniajca

mov ie, #00000000b      ;wycz przerwania
;------------------------------------------------------------------------------
mov p1, #0              ;wcz ledy
clr p3.7                ;zawie wskanik aktywnoci
mov r5, #time           ;czas wiecenia ledw pen moc
;=============================================================== gwna ptla =
loop:
loop1:                  ;4 ptle wiecenia ledw (eby zwikszy zakres czasu)
djnz r7, $
djnz r6, loop1
cpl p3.7                ;zmieniaj wskanik aktywnoci

loop2:
djnz r7, $
djnz r6, loop2
cpl p3.7

loop3:
djnz r7, $
djnz r6, loop3
cpl p3.7

loop4:
djnz r7, $
djnz r6, loop4
cpl p3.7

djnz r5, loop
;======================================================= koniec gwnej ptli =
setb p3.7               ;zga wskanik aktywnoci
mov r5, #255
mov ie, #10000010b      ;wcz przerwania z t0

post:
mov bright, r5

mov r6, #fadeout
post1:
mov r7, #040h
djnz r7, $
djnz r6, post1
djnz r5, post           ;ptla ciemniajca

mov ie, #00000000b      ;wycz przerwania

mov p1, #255            ;zga ledy
orl pcon, #00000011b    ;zamroenie, koniec pracy
ajmp reset
;============================================== przerwanie timera/licznika t0 =
intt0:                  ;pwm
push psw
push acc

inc pwm                 ;zwikszaj licznik pwm do porwna
clr c
mov a, pwm              ;dodaj licznik do jasnoci
add a, bright
jc intt01

mov p1, #255            ;zga ledy
pop acc
pop psw
reti                    ;powrt

intt01:                 ;zawie ledy
mov p1, #0
pop acc
pop psw
reti                    ;powrt
;===================================================================== koniec =
end
